//<c>   Copyright 1987-2000 by Gerry J. Danen; all rights reserved.

//<t>   Extract printable strings

/*
        Operation:  Extracts contiguous character strings from input file.
        Ignores all strings < 3 characters.  String must start with an
        alphabetic.  Outputs selected strings, one per line.
*/
#include"gd_tools.h"
#include<io.h>


#define pgVERS_ "V2.01"
#define pgTITL_ "Find Text in Files"
#define pgCOPR_ "1987"


#define BUFSIZE 2052


// states for finite-state automaton

#define START   1
#define FIRST   2
#define SECOND  3
#define REST    4

// externals

int     buffer[BUFSIZE];
int     file_status = 0;


UCHAR   get_a_char( FILE *f )
{
    UCHAR       c;

    if ( ! feof(f) )
        c = getc(f);
    if ( feof(f) )
    {
        file_status = EOF ;
        c = 0 ;
    }
    return( c );
}


void    main( int argc, char *argv[] )
{
    FILE        *fdin ;
    INT16       c, last[9], state;
    UCHAR       pathname[64];

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc != 2 )
    {
        fprintf( stderr, "\n\aPlease specify file to be examined.\n" );
        exit( 1 );
    }
    st_cpy( pathname, argv[1], 64 );
    _strupr( pathname );
    if ( (fdin = fopen(pathname,"rb")) == NULL )
    {
        fprintf( stderr, "\n\aCould not open file \"%s\".\n", pathname );
        exit( 1 );
    }
    fprintf( stderr, "\nWait please" );
    fprintf( stdout, "\n------ File %s ------\n", pathname );

    // main loop

    for ( c = get_a_char(fdin), state = START ; file_status != EOF ; c = get_a_char(fdin) )
    {
        switch (state)
        {
            case START:
                if ( isalpha(c) )
                {
                    last[0] = c;
                    state = FIRST;
                }
                else
                    state = START;
                break;

            case FIRST:
                if ( isprint(c) )
                {
                    last[1] = c;
                    state = SECOND;
                }
                else
                {
                    state = START;
                }
                break;

            case SECOND:
                if ( isprint(c) )
                {
                    putchar(last[0]);
                    putchar(last[1]);
                    putchar(c);
                    state = REST;
                }
                else
                    state = START;
                break;

            case REST:
                if ( isprint(c) )
                {
                    putchar(c);
                    state = REST;
                }
                else
                {
                    putchar( NEWLINE );
                    state = START;
                }
                break;
        }
    }
    fprintf( stderr, "\nFinished." );
    exit( 0 );
}
